#include <stdio.h>
#include <stdlib.h>

void sort(long long a[],int n){
    for(int i=0; i<n; i++)
        for(int j=i+1; j<n; j++){
            if(a[i]>a[j]){
                int l=a[i];
                a[i]=a[j];
                a[j]=l;
            }
        }


}

int main()
{
    int n,m,l;
    short t;
    long long a[75000];
    long long b[75000];
    scanf("%hd",&t);
    for(int i=0; i<t; i++){
        l=1;
        scanf("%d%d",&n,&m);
        for(int j=0; j<n; j++){
            scanf("%ld",&a[j]);
        }
        for(int j=0; j<m; j++){
           scanf("%ld",&b[j]);
        }
        sort(a, n-1);
        sort(b, m-1);
        long long min=a[1]-a[0];
        for(int j=1; j<(n-1);j++)
            if(a[j+1]-a[j]<min)
                min=abs(a[j+1]-a[j]);
        long k=a[0]%min;
        for(int j=1;j<n;j++)
            if(k!=a[j]%min)
                l=0;
        for(int j=0;j<m;j++)
            if(k==b[j]%min)
                l=0;

    printf("%d",l);
    printf("\n");
    }
}